package com.godoro.samples.file;

import java.util.*;
import java.io.*;

public class School {

	private Hashtable students=new Hashtable();

  public School() {
  }
	public void addStudent(Student student){
		String id=student.getId();
		if(!containsStudent(id)){
			students.put(id,student);
		}else{
			throw new IllegalArgumentException("Student already exists : "+id);
		}
	}
	public boolean containsStudent(String id){
		return getStudent(id)!=null;
	}
	public void removeStudent(String id){
		if(containsStudent(id)){
			students.remove(id);
		}else{
			throw new IllegalArgumentException("Student not found : "+id);
		}

	}
	public Student getStudent(String id){
		return (Student) students.get(id);
	}
	public Hashtable getStudents(){
		return students;
	}

	public Vector findGradeStudents(int grade){
		Vector results=new Vector();
		Enumeration e=students.elements();
		while(e.hasMoreElements()){
			Student student=(Student) e.nextElement();
			if(student.getGrade()==grade){
				results.add(student);
			}
		}
		return results;
	}
	public Vector findAboveAvaregeStudents(float average){
		Vector results=new Vector();
		Enumeration e=students.elements();
		while(e.hasMoreElements()){
			Student student=(Student) e.nextElement();
			if(student.getAverage()>=average){
				results.add(student);
			}
		}
		return results;
	}

	public void store(File file)
			throws IOException
	{
		FileWriter fw=new FileWriter(file);
		BufferedWriter out=new BufferedWriter(fw);
		Enumeration e=students.keys();
		while(e.hasMoreElements()){
			String id=(String) e.nextElement();
			Student student=getStudent(id);
			String line=Student.format(student);
			out.write(line+"\r\n");
		}
		out.close();
	}

	public void load(File file)
			throws IOException
	{
		FileReader fr=new FileReader(file);
		BufferedReader in=new BufferedReader(fr);
		String line=null;
		while((line=in.readLine())!=null){
			Student student=Student.parse(line);
			addStudent(student);
		}
		in.close();
	}

	public static void main(String[] args)
			throws Exception
	{
		File file=new File("School.txt");
		School school=new School();
		if(file.exists()){
			school.load(file);
		}
		Student student=new Student("1244","Orhan Gencebay",2);
		school.addStudent(student);
		school.store(file);

		Vector vector=school.findGradeStudents(2);
		for(int i=0;i<vector.size();i++){
			Student result=(Student) vector.get(i);
			String name=result.getName();
			System.out.println("Name "+name);
		}
	}
}
